"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


PendleAddLiquidityParamsAmountTypedDict = TypeAliasType(
    "PendleAddLiquidityParamsAmountTypedDict", Union[float, str]
)
r"""The amount of liquidity you would like to add to the market denominated in the market's Underlying Token."""


PendleAddLiquidityParamsAmount = TypeAliasType(
    "PendleAddLiquidityParamsAmount", Union[float, str]
)
r"""The amount of liquidity you would like to add to the market denominated in the market's Underlying Token."""


class PendleAddLiquidityParamsTypedDict(TypedDict):
    market_address: str
    r"""The address identifying which Pendle Market you would like to add liquidity to."""
    amount: PendleAddLiquidityParamsAmountTypedDict
    r"""The amount of liquidity you would like to add to the market denominated in the market's Underlying Token."""
    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""
    action_type: Literal["PENDLE_ADD_LIQUIDITY"]


class PendleAddLiquidityParams(BaseModel):
    market_address: str
    r"""The address identifying which Pendle Market you would like to add liquidity to."""

    amount: PendleAddLiquidityParamsAmount
    r"""The amount of liquidity you would like to add to the market denominated in the market's Underlying Token."""

    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["PENDLE_ADD_LIQUIDITY"]],
            AfterValidator(validate_const("PENDLE_ADD_LIQUIDITY")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "PENDLE_ADD_LIQUIDITY"
