"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


PendleBuyYtRequestAmountTypedDict = TypeAliasType(
    "PendleBuyYtRequestAmountTypedDict", Union[float, str]
)
r"""The amount of market's Underlying Token you would like to sell for market's Yield Token (YT)."""


PendleBuyYtRequestAmount = TypeAliasType("PendleBuyYtRequestAmount", Union[float, str])
r"""The amount of market's Underlying Token you would like to sell for market's Yield Token (YT)."""


class PendleBuyYtRequestTypedDict(TypedDict):
    market_address: str
    r"""The address of the market identifying which Yield Token (YT) you would like to buy."""
    amount: PendleBuyYtRequestAmountTypedDict
    r"""The amount of market's Underlying Token you would like to sell for market's Yield Token (YT)."""
    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    action_type: Literal["PENDLE_BUY_YT"]


class PendleBuyYtRequest(BaseModel):
    market_address: str
    r"""The address of the market identifying which Yield Token (YT) you would like to buy."""

    amount: PendleBuyYtRequestAmount
    r"""The amount of market's Underlying Token you would like to sell for market's Yield Token (YT)."""

    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["PENDLE_BUY_YT"]],
            AfterValidator(validate_const("PENDLE_BUY_YT")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "PENDLE_BUY_YT"
