"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


PendleRemoveLiquidityRequestAmountTypedDict = TypeAliasType(
    "PendleRemoveLiquidityRequestAmountTypedDict", Union[float, str]
)
r"""The amount of liquidity you would like to remove from the market denominated in the market's Liquidity Provider Token (LP)."""


PendleRemoveLiquidityRequestAmount = TypeAliasType(
    "PendleRemoveLiquidityRequestAmount", Union[float, str]
)
r"""The amount of liquidity you would like to remove from the market denominated in the market's Liquidity Provider Token (LP)."""


class PendleRemoveLiquidityRequestTypedDict(TypedDict):
    market_address: str
    r"""The address identifying which Pendle Market you would like to remove liquidity from."""
    amount: PendleRemoveLiquidityRequestAmountTypedDict
    r"""The amount of liquidity you would like to remove from the market denominated in the market's Liquidity Provider Token (LP)."""
    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    action_type: Literal["PENDLE_REMOVE_LIQUIDITY"]


class PendleRemoveLiquidityRequest(BaseModel):
    market_address: str
    r"""The address identifying which Pendle Market you would like to remove liquidity from."""

    amount: PendleRemoveLiquidityRequestAmount
    r"""The amount of liquidity you would like to remove from the market denominated in the market's Liquidity Provider Token (LP)."""

    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["PENDLE_REMOVE_LIQUIDITY"]],
            AfterValidator(validate_const("PENDLE_REMOVE_LIQUIDITY")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "PENDLE_REMOVE_LIQUIDITY"
