"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


PendleSellYtParamsAmountTypedDict = TypeAliasType(
    "PendleSellYtParamsAmountTypedDict", Union[float, str]
)
r"""The amount of market's Yield Token (YT) you would like to sell for market's Underlying Token."""


PendleSellYtParamsAmount = TypeAliasType("PendleSellYtParamsAmount", Union[float, str])
r"""The amount of market's Yield Token (YT) you would like to sell for market's Underlying Token."""


class PendleSellYtParamsTypedDict(TypedDict):
    market_address: str
    r"""The address of the market identifying which Yield Token (YT) you would like to sell."""
    amount: PendleSellYtParamsAmountTypedDict
    r"""The amount of market's Yield Token (YT) you would like to sell for market's Underlying Token."""
    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""
    action_type: Literal["PENDLE_SELL_YT"]


class PendleSellYtParams(BaseModel):
    market_address: str
    r"""The address of the market identifying which Yield Token (YT) you would like to sell."""

    amount: PendleSellYtParamsAmount
    r"""The amount of market's Yield Token (YT) you would like to sell for market's Underlying Token."""

    max_slippage_percent: float
    r"""The maximum slippage allowed in percent. e.g. `1` means `1%` slippage allowed."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["PENDLE_SELL_YT"]],
            AfterValidator(validate_const("PENDLE_SELL_YT")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "PENDLE_SELL_YT"
