"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from .token_enum import TokenEnum
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
from enum import Enum
import pydantic
from pydantic.functional_validators import AfterValidator
from typing import Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


SetAllowanceRequestTokenTypedDict = TypeAliasType(
    "SetAllowanceRequestTokenTypedDict", Union[TokenEnum, str]
)
r"""The symbol or address of the token for which the allowance is set.."""


SetAllowanceRequestToken = TypeAliasType(
    "SetAllowanceRequestToken", Union[TokenEnum, str]
)
r"""The symbol or address of the token for which the allowance is set.."""


class SetAllowanceRequestContractEnum(str, Enum):
    AAVE_V3_POOL = "AaveV3Pool"
    AERODROME_BASIC_ROUTER = "AerodromeBasicRouter"
    AERODROME_SLIPSTREAM_ROUTER = "AerodromeSlipstreamRouter"
    AERODROME_SLIPSTREAM_NONFUNGIBLE_POSITION_MANAGER = (
        "AerodromeSlipstreamNonfungiblePositionManager"
    )
    UNISWAP_V3_ROUTER = "UniswapV3Router"
    UNISWAP_V3_NFT_POSITION_MANAGER = "UniswapV3NFTPositionManager"
    MORPHO = "Morpho"
    SKY_DAI_USDS_CONVERTER = "SkyDaiUsdsConverter"
    SKY_USDC_USDS_CONVERTER = "SkyUsdcUsdsConverter"
    SKY_USDS_VAULT = "SkyUsdsVault"
    PENDLE_ROUTER = "PendleRouter"


SetAllowanceRequestContractUnionTypedDict = TypeAliasType(
    "SetAllowanceRequestContractUnionTypedDict",
    Union[SetAllowanceRequestContractEnum, str],
)
r"""The name or address of the contract to set spending allowance for."""


SetAllowanceRequestContractUnion = TypeAliasType(
    "SetAllowanceRequestContractUnion", Union[SetAllowanceRequestContractEnum, str]
)
r"""The name or address of the contract to set spending allowance for."""


SetAllowanceRequestAmountTypedDict = TypeAliasType(
    "SetAllowanceRequestAmountTypedDict", Union[float, str]
)
r"""The amount to set the allowance to."""


SetAllowanceRequestAmount = TypeAliasType(
    "SetAllowanceRequestAmount", Union[float, str]
)
r"""The amount to set the allowance to."""


class SetAllowanceRequestTypedDict(TypedDict):
    r"""Request model for increasing token allowance for a contract."""

    token: SetAllowanceRequestTokenTypedDict
    r"""The symbol or address of the token for which the allowance is set.."""
    contract: SetAllowanceRequestContractUnionTypedDict
    r"""The name or address of the contract to set spending allowance for."""
    amount: SetAllowanceRequestAmountTypedDict
    r"""The amount to set the allowance to."""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    action_type: Literal["SET_ALLOWANCE"]


class SetAllowanceRequest(BaseModel):
    r"""Request model for increasing token allowance for a contract."""

    token: SetAllowanceRequestToken
    r"""The symbol or address of the token for which the allowance is set.."""

    contract: SetAllowanceRequestContractUnion
    r"""The name or address of the contract to set spending allowance for."""

    amount: SetAllowanceRequestAmount
    r"""The amount to set the allowance to."""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    ACTION_TYPE: Annotated[
        Annotated[
            Optional[Literal["SET_ALLOWANCE"]],
            AfterValidator(validate_const("SET_ALLOWANCE")),
        ],
        pydantic.Field(alias="action_type"),
    ] = "SET_ALLOWANCE"
