"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


class UniswapQuoteBuyExactlyChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


class UniswapQuoteBuyExactlyTokenInToken(str, Enum):
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    ONE_INCH = "1INCH"
    AAVE = "AAVE"
    BAL = "BAL"
    CB_BTC = "cbBTC"
    CB_ETH = "cbETH"
    CRV = "CRV"
    CRV_USD = "crvUSD"
    DAI = "DAI"
    ENS = "ENS"
    ET_HX = "ETHx"
    FRAX = "FRAX"
    FXS = "FXS"
    GHO = "GHO"
    KNC = "KNC"
    LDO = "LDO"
    LINK = "LINK"
    LUSD = "LUSD"
    MKR = "MKR"
    OS_ETH = "osETH"
    PYUSD = "PYUSD"
    R_ETH = "rETH"
    RPL = "RPL"
    RS_ETH = "rsETH"
    S_DAI = "sDAI"
    SNX = "SNX"
    STG = "STG"
    S_US_DE = "sUSDe"
    T_BTC = "tBTC"
    UNI = "UNI"
    USDC = "USDC"
    US_DE = "USDe"
    USDS = "USDS"
    USDT = "USDT"
    WBTC = "WBTC"
    WE_ETH = "weETH"
    WETH = "WETH"
    WST_ETH = "wstETH"
    ARB = "ARB"
    EURS = "EURS"
    MAI = "MAI"
    USD_CE = "USDCe"
    AERO = "AERO"
    EUR = "EUR"
    VIRTUAL = "VIRTUAL"


class UniswapQuoteBuyExactlyTokenOutToken(str, Enum):
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    ONE_INCH = "1INCH"
    AAVE = "AAVE"
    BAL = "BAL"
    CB_BTC = "cbBTC"
    CB_ETH = "cbETH"
    CRV = "CRV"
    CRV_USD = "crvUSD"
    DAI = "DAI"
    ENS = "ENS"
    ET_HX = "ETHx"
    FRAX = "FRAX"
    FXS = "FXS"
    GHO = "GHO"
    KNC = "KNC"
    LDO = "LDO"
    LINK = "LINK"
    LUSD = "LUSD"
    MKR = "MKR"
    OS_ETH = "osETH"
    PYUSD = "PYUSD"
    R_ETH = "rETH"
    RPL = "RPL"
    RS_ETH = "rsETH"
    S_DAI = "sDAI"
    SNX = "SNX"
    STG = "STG"
    S_US_DE = "sUSDe"
    T_BTC = "tBTC"
    UNI = "UNI"
    USDC = "USDC"
    US_DE = "USDe"
    USDS = "USDS"
    USDT = "USDT"
    WBTC = "WBTC"
    WE_ETH = "weETH"
    WETH = "WETH"
    WST_ETH = "wstETH"
    ARB = "ARB"
    EURS = "EURS"
    MAI = "MAI"
    USD_CE = "USDCe"
    AERO = "AERO"
    EUR = "EUR"
    VIRTUAL = "VIRTUAL"


class UniswapQuoteBuyExactlyFeeEnum(str, Enum):
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """

    ZERO_DOT_01 = "0.01"
    ZERO_DOT_05 = "0.05"
    ZERO_DOT_3 = "0.3"
    ONE_DOT_0 = "1.0"


UniswapQuoteBuyExactlyAmountOutTypedDict = TypeAliasType(
    "UniswapQuoteBuyExactlyAmountOutTypedDict", Union[float, str]
)
r"""The amount of the token to swap to"""


UniswapQuoteBuyExactlyAmountOut = TypeAliasType(
    "UniswapQuoteBuyExactlyAmountOut", Union[float, str]
)
r"""The amount of the token to swap to"""


class UniswapQuoteBuyExactlyRequestTypedDict(TypedDict):
    amount_out: UniswapQuoteBuyExactlyAmountOutTypedDict
    r"""The amount of the token to swap to"""
    chain: UniswapQuoteBuyExactlyChain
    r"""The chain to use."""
    token_in: UniswapQuoteBuyExactlyTokenInToken
    r"""The symbol of the token to swap from."""
    token_out: UniswapQuoteBuyExactlyTokenOutToken
    r"""The symbol of the token to swap to."""
    fee: UniswapQuoteBuyExactlyFeeEnum
    r"""The fee to pay for the swap"""


class UniswapQuoteBuyExactlyRequest(BaseModel):
    amount_out: Annotated[
        UniswapQuoteBuyExactlyAmountOut,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ]
    r"""The amount of the token to swap to"""

    chain: Annotated[
        UniswapQuoteBuyExactlyChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapQuoteBuyExactlyChain.ARBITRUM_MAINNET
    r"""The chain to use."""

    token_in: Annotated[
        UniswapQuoteBuyExactlyTokenInToken,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapQuoteBuyExactlyTokenInToken.USDC
    r"""The symbol of the token to swap from."""

    token_out: Annotated[
        UniswapQuoteBuyExactlyTokenOutToken,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapQuoteBuyExactlyTokenOutToken.USDT
    r"""The symbol of the token to swap to."""

    fee: Annotated[
        UniswapQuoteBuyExactlyFeeEnum,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UniswapQuoteBuyExactlyFeeEnum.ZERO_DOT_01
    r"""The fee to pay for the swap"""
