"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from compass_api_sdk.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from pydantic import model_serializer
from typing_extensions import Annotated, NotRequired, TypedDict


class VaultsVaultChain(str, Enum):
    r"""The chain to use."""

    BASE_MAINNET = "base:mainnet"
    ETHEREUM_MAINNET = "ethereum:mainnet"
    ARBITRUM_MAINNET = "arbitrum:mainnet"


class VaultsVaultRequestTypedDict(TypedDict):
    chain: VaultsVaultChain
    r"""The chain to use."""
    block: NotRequired[Nullable[int]]
    r"""Optional block number (defaults to latest)."""
    vault_address: str
    r"""The vault address of the desired vault position."""
    user_address: NotRequired[Nullable[str]]
    r"""The user address of the desired vault position. Only include if you would like the user position included in the response. Defaults to `None`."""


class VaultsVaultRequest(BaseModel):
    chain: Annotated[
        VaultsVaultChain,
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = VaultsVaultChain.ETHEREUM_MAINNET
    r"""The chain to use."""

    block: Annotated[
        OptionalNullable[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UNSET
    r"""Optional block number (defaults to latest)."""

    vault_address: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ] = "0x182863131F9a4630fF9E27830d945B1413e347E8"
    r"""The vault address of the desired vault position."""

    user_address: Annotated[
        OptionalNullable[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = UNSET
    r"""The user address of the desired vault position. Only include if you would like the user position included in the response. Defaults to `None`."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["block", "user_address"]
        nullable_fields = ["block", "user_address"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
